diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 2448bf04a..3a74f8d2c 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -16,9 +16,9 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.entity.PlayerRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
@@ -39,7 +39,7 @@ import static org.lwjgl.opengl.GL11.glPushMatrix;
 
 // Referenced classes of package net.minecraft.src:
 //            RenderBlocks, MapItemRenderer, ItemStack, Block, 
-//            RenderEngine, EntityLiving, TessellatorStandard, EntityPlayer,
+//            RenderEngine, EntityLiving, Tessellator, EntityPlayer,
 //            RenderHelper, MathHelper, World, Item, 
 //            ItemMap, EntityPlayerSP, RenderManager, RenderPlayer, 
 //            Material, BlockFire, InventoryPlayer
@@ -82,7 +82,7 @@ public class ItemRenderer
         GL11.glPushMatrix();
         if(itemstack != null)
         {
-            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemFirstPerson(TessellatorStandard.instance,this, player, itemstack, partialTick);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemFirstPerson(Tessellator.instance,this, player, itemstack, partialTick);
         } else
         {
         	float brightness = 1.0f;
@@ -180,7 +180,7 @@ public class ItemRenderer
 
 	private void renderInsideOfBlock(float partialTicks, IconCoordinate texture) {
         if (texture == null) return;
-		TessellatorStandard tessellator = TessellatorStandard.instance;
+		Tessellator tessellator = Tessellator.instance;
 		
 		float brightness = 0.1f;
 		if(mc.fullbright) {
@@ -214,7 +214,7 @@ public class ItemRenderer
 
     private void renderWarpedTextureOverlay(float f)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         float f1 = mc.thePlayer.getBrightness(f);
         if (mc.fullbright) f1 = 1.0f;
         GL11.glColor4f(f1, f1, f1, 0.5F);
@@ -242,7 +242,7 @@ public class ItemRenderer
 
     private void renderFireInFirstPerson(float f)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.9F);
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index d0513efb6..e3ef32389 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -5,7 +5,7 @@ import net.minecraft.client.Minecraft;
 import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.option.KeyBinding;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.world.Dimension;
@@ -171,7 +171,7 @@ public class LoadingScreenRenderer
         GL11.glMatrixMode(GL_MODELVIEW);
         GL11.glLoadIdentity();
         GL11.glTranslatef(0.0F, 0.0F, -200F);
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
         int bgTexture = minecraft.renderEngine.getTexture(backgroundPath);
         GL11.glBindTexture(GL_TEXTURE_2D, bgTexture);
         float f = 32F;
diff --git a/src/main/java/net/minecraft/client/render/MapItemRenderer.java b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
index c32c6d4c7..63cc85662 100644
--- a/src/main/java/net/minecraft/client/render/MapItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/MapItemRenderer.java
@@ -3,10 +3,10 @@ package net.minecraft.client.render;
 import java.awt.image.BufferedImage;
 import java.util.Iterator;
 
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
@@ -15,7 +15,7 @@ import net.minecraft.core.world.saveddata.maps.MapWaypoint;
 
 // Referenced classes of package net.minecraft.src:
 //            RenderEngine, MapData, MapColor, GameSettings, 
-//            TessellatorStandard, MapCoord, FontRenderer, EntityPlayer
+//            Tessellator, MapCoord, FontRenderer, EntityPlayer
 
 public class MapItemRenderer
 {
@@ -71,7 +71,7 @@ public class MapItemRenderer
         renderengine.updateTextureData(mapImageData, 128, 128, mapTexture);
         int j = 0;
         int k = 0;
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         float f = 0.0F;
         //renders the map
         GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, mapTexture);
diff --git a/src/main/java/net/minecraft/client/render/Polygon.java b/src/main/java/net/minecraft/client/render/Polygon.java
index 07d173114..a6ad40dce 100644
--- a/src/main/java/net/minecraft/client/render/Polygon.java
+++ b/src/main/java/net/minecraft/client/render/Polygon.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render;
 
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.phys.Vec3d;
 
 public class Polygon
@@ -35,7 +35,7 @@ public class Polygon
         vertexPositions = vertices;
     }
 
-    public void draw(TessellatorStandard tessellator, float scale)
+    public void draw(Tessellator tessellator, float scale)
     {
         Vec3d vec3d = vertexPositions[1].vector3D.subtract(vertexPositions[0].vector3D);
         Vec3d vec3d1 = vertexPositions[1].vector3D.subtract(vertexPositions[2].vector3D);
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 60e0f15ca..0c9c470cd 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -6,13 +6,13 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, BlockRail, TessellatorStandard, IBlockAccess,
+//            Block, BlockRail, Tessellator, IBlockAccess,
 //            BlockBed, ModelBed, BlockRedstoneRepeater, BlockPistonBase, 
 //            BlockPistonExtension, Vec3D, BlockFire, BlockRedstoneWire, 
 //            EntityRenderer, BlockFluid, MathHelper, Material, 
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 17ed21139..e28a7e0fa 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -15,8 +15,7 @@ import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
@@ -47,18 +46,11 @@ import java.util.Arrays;
 import java.util.List;
 import java.util.Random;
 
-
-import static org.lwjgl.opengl.GL11.GL_FOG;
-import static org.lwjgl.opengl.GL11.GL_LINES;
-import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
-import static org.lwjgl.opengl.GL11.glColor4f;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-import static org.lwjgl.opengl.GL11.glLineWidth;
+import static org.lwjgl.opengl.GL11.*;
 
 // Referenced classes of package net.minecraft.src:
 //            IWorldAccess, GLAllocation, RenderList, OpenGlCapsChecker, 
-//            TessellatorStandard, World, RenderManager, RenderBlocks,
+//            Tessellator, World, RenderManager, RenderBlocks,
 //            Block, GameSettings, BlockLeaves, WorldRenderer, 
 //            Entity, MathHelper, EntitySorter, TileEntityRenderer, 
 //            ICamera, EntityLiving, TileEntity, RenderHelper, 
@@ -122,7 +114,7 @@ public class RenderGlobal
         GL11.glPopMatrix();
 
         // Set up call list for sky
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         glSkyList = starGLCallList + 1;
         GL11.glNewList(glSkyList, GL11.GL_COMPILE);
         byte byte1 = 64;
@@ -146,7 +138,7 @@ public class RenderGlobal
     private void setupStarsCallList()
     {
         Random random = new Random(10842L);
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         for(int i = 0; i < 1500; i++)
         {
@@ -365,7 +357,7 @@ public class RenderGlobal
         float radius = 512;
         long worldTime = worldObj.getWorldTime();
 
-        TessellatorStandard.instance.startDrawingQuads();
+        Tessellator.instance.startDrawingQuads();
         for (float x = -radius; x < radius; x += 8f)
         {
             for (float z = -radius; z < radius; z += 8f)
@@ -392,7 +384,7 @@ public class RenderGlobal
                 );
             }
         }
-        TessellatorStandard.instance.draw();
+        Tessellator.instance.draw();
 
         GL11.glEnable(GL11.GL_FOG);
         GL11.glEnable(GL11.GL_ALPHA_TEST);
@@ -405,7 +397,7 @@ public class RenderGlobal
     private void renderAuroraBeam(float x, float y, float z, float xOffset, float zOffset, float redOffset, float greenOffset, float blueOffset, float scale, float transparency)
     {
         float width = 16f;
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.setColorRGBA_F(0 / 255f + redOffset, 255 / 255f + greenOffset, 127 / 255f + blueOffset, transparency);
         tessellator.addVertexWithUV(x - xOffset * scale * width, y - scale * 256, z - zOffset * scale * width, 1.0, 1.0);
         tessellator.addVertexWithUV(x - xOffset * scale * width, y + scale, z - zOffset * scale * width, 1.0, 0.0);
@@ -433,7 +425,7 @@ public class RenderGlobal
         TileEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
         List<Entity> loadedEntities = worldObj.getLoadedEntityList();
         countEntitiesTotal = loadedEntities.size();
-        Tessellator tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         // Render weather effects
         for (int i = 0; i < worldObj.weatherEffects.size(); i++)
         {
@@ -832,107 +824,91 @@ public class RenderGlobal
             return;
         }
         float celestialAngle = worldObj.getCelestialAngle(partialTick);
-        GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-        Vec3d vec3d = worldObj.getSkyColor(mc.activeCamera, partialTick);
-        float f1 = (float)vec3d.xCoord;
-        float f2 = (float)vec3d.yCoord;
-        float f3 = (float)vec3d.zCoord;
-        GL11.glColor3f(f1, f2, f3);
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        GL11.glDisable(GL_TEXTURE_2D);
+        Vec3d skyColor = worldObj.getSkyColor(mc.activeCamera, partialTick);
+        float r = (float)skyColor.xCoord;
+        float g = (float)skyColor.yCoord;
+        float b = (float)skyColor.zCoord;
+        GL11.glColor3f(r, g, b);
+        Tessellator t = Tessellator.instance;
         GL11.glDepthMask(false);
-        GL11.glEnable(2912 /*GL_FOG*/);
-        GL11.glColor3f(f1, f2, f3);
+        GL11.glEnable(GL_FOG);
+        GL11.glColor3f(r, g, b);
         GL11.glCallList(glSkyList);
-        GL11.glDisable(2912 /*GL_FOG*/);
-        GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
-        GL11.glEnable(3042 /*GL_BLEND*/);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glDisable(GL_FOG);
+        GL11.glDisable(GL_ALPHA_TEST);
+        GL11.glEnable(GL_BLEND);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         Lighting.disable();
-        float[] af = worldObj.worldType.getSunriseColor(celestialAngle, partialTick);
-        if(af != null)
+        float[] sunriseColor = worldObj.worldType.getSunriseColor(celestialAngle, partialTick);
+        if(sunriseColor != null)
         {
-            GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-            GL11.glShadeModel(7425 /*GL_SMOOTH*/);
+            GL11.glDisable(GL_TEXTURE_2D);
+            GL11.glShadeModel(GL_SMOOTH);
             GL11.glPushMatrix();
             GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
             GL11.glRotatef(90F, 1.0F, 0.0F, 0.0F);
             GL11.glRotatef(celestialAngle <= 0.5F ? 0.0F : 180F, 0.0F, 0.0F, 1.0F);
-            float f10 = af[0];
-            float f12 = af[1];
-            float f14 = af[2];
-            tessellator.startDrawing(6);
-            tessellator.setColorRGBA_F(f10, f12, f14, af[3]);
-            tessellator.addVertex(0.0D, 100D, 0.0D);
-            int i = 16;
-            tessellator.setColorRGBA_F(af[0], af[1], af[2], 0.0F);
-            for(int j = 0; j <= i; j++)
+            float sr = sunriseColor[0];
+            float sg = sunriseColor[1];
+            float sb = sunriseColor[2];
+            t.startDrawing(GL_TRIANGLE_FAN);
+            t.setColorRGBA_F(sr, sg, sb, sunriseColor[3]);
+            t.addVertex(0.0D, 100D, 0.0D);
+            int numVertices = 16;
+            t.setColorRGBA_F(sunriseColor[0], sunriseColor[1], sunriseColor[2], 0.0F);
+            for(int i = 0; i <= numVertices; i++)
             {
-                float f20 = ((float)j * 3.141593F * 2.0F) / (float)i;
-                float f21 = MathHelper.sin(f20);
-                float f22 = MathHelper.cos(f20);
-                tessellator.addVertex(f21 * 120F, f22 * 120F, -f22 * 40F * af[3]);
+                float theta = ((float)i * MathHelper.PI * 2.0F) / (float)numVertices;
+                float sunriseX = MathHelper.sin(theta);
+                float sunriseYZ = MathHelper.cos(theta);
+                t.addVertex(sunriseX * 120F, sunriseYZ * 120F, -sunriseYZ * 40F * sunriseColor[3]);
             }
 
-            tessellator.draw();
+            t.draw();
             GL11.glPopMatrix();
-            GL11.glShadeModel(7424 /*GL_FLAT*/);
+            GL11.glShadeModel(GL_FLAT);
         }
-        GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
-        GL11.glBlendFunc(770, 1);
+        GL11.glEnable(GL_TEXTURE_2D);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE);
         GL11.glPushMatrix();
-        float f6 = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weather.overworldClear ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
+        float sunAlpha = 1.0F - (worldObj.getCurrentWeather() != null && worldObj.getCurrentWeather() != Weather.overworldClear ? (worldObj.weatherManager.getWeatherIntensity() * worldObj.weatherManager.getWeatherPower()) * 1.5f : 0.0f);
         if (!mc.gameSettings.fog.value && worldObj.getCurrentWeather() == Weather.overworldFog)
         {
-            f6 = 1f;
+            sunAlpha = 1f;
         }
-        float f9 = 0.0F;
-        float f11 = 0.0F;
-        float f13 = 0.0F;
-
-        // Calculate sun and moon alpha
-//        float sunAlpha = 1.0f;
-//        float moonAlpha = 1.0f;
-//        int cycleLength = worldObj.getWorldType().worldProvider.getDayNightCycleLengthTicks();
-//        float tickWithinCycle = (int)(worldObj.getWorldTime() % cycleLength) + partialTick;
-//        float fadePercentage = 0.05f;
-//        if (tickWithinCycle >= (cycleLength / 2f) - cycleLength * fadePercentage && tickWithinCycle <= (cycleLength / 2f) + cycleLength * fadePercentage)
-//        {
-//            float tickWithinSunFadeOut = tickWithinCycle - ((cycleLength / 2f) - cycleLength * fadePercentage);
-//            float tickWithinMoonFadeIn = tickWithinCycle - (cycleLength / 2f);
-//            float percentageWithinSunFadeOut = tickWithinSunFadeOut / (cycleLength * fadePercentage);
-//            float percentageWithinMoonFadeIn = tickWithinMoonFadeIn / (cycleLength * fadePercentage);
-//            sunAlpha = percentageWithinSunFadeOut;
-//            moonAlpha = percentageWithinMoonFadeIn;
-//        }
-
-        GL11.glTranslatef(f9, f11, f13);
-        GL11.glRotatef(0.0F, 0.0F, 0.0F, 1.0F);
+        float x = 0.0F;
+        float y = 0.0F;
+        float z = 0.0F;
+
+        GL11.glTranslatef(x, y, z);
+        GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
         GL11.glRotatef(celestialAngle * 360F, 0.0F, 0.0F, 1.0F);
 
         // Render sun
         float f15 = 30F;
         GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/terrain/sun.png"));
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, f6);
-        tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(-f15, 100D, -f15, 0.0D, 0.0D);
-        tessellator.addVertexWithUV(f15, 100D, -f15, 1.0D, 0.0D);
-        tessellator.addVertexWithUV(f15, 100D, f15, 1.0D, 1.0D);
-        tessellator.addVertexWithUV(-f15, 100D, f15, 0.0D, 1.0D);
-        tessellator.draw();
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
+        t.startDrawingQuads();
+        t.addVertexWithUV(-f15, 100D, -f15, 0.0D, 0.0D);
+        t.addVertexWithUV(f15, 100D, -f15, 1.0D, 0.0D);
+        t.addVertexWithUV(f15, 100D, f15, 1.0D, 1.0D);
+        t.addVertexWithUV(-f15, 100D, f15, 0.0D, 1.0D);
+        t.draw();
 
         // Render moon
         f15 = 20F;
         GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/terrain/moon.png"));
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, f6);
-        tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(-f15, -100D, f15, 1.0D, 1.0D);
-        tessellator.addVertexWithUV(f15, -100D, f15, 0.0D, 1.0D);
-        tessellator.addVertexWithUV(f15, -100D, -f15, 0.0D, 0.0D);
-        tessellator.addVertexWithUV(-f15, -100D, -f15, 1.0D, 0.0D);
-        tessellator.draw();
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
+        t.startDrawingQuads();
+        t.addVertexWithUV(-f15, -100D, f15, 1.0D, 1.0D);
+        t.addVertexWithUV(f15, -100D, f15, 0.0D, 1.0D);
+        t.addVertexWithUV(f15, -100D, -f15, 0.0D, 0.0D);
+        t.addVertexWithUV(-f15, -100D, -f15, 1.0D, 0.0D);
+        t.draw();
 
         GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
-        float f17 = worldObj.getStarBrightness(partialTick) * f6;
+        float f17 = worldObj.getStarBrightness(partialTick) * sunAlpha;
         if(f17 > 0.0F)
         {
             GL11.glColor4f(f17, f17, f17, f17);
@@ -945,15 +921,19 @@ public class RenderGlobal
         GL11.glPopMatrix();
         if(worldObj.worldType.hasGround())
         {
-            GL11.glColor3f(f1 * 0.2F + 0.04F, f2 * 0.2F + 0.04F, f3 * 0.6F + 0.1F);
+            GL11.glColor3f(r * 0.2F + 0.04F, g * 0.2F + 0.04F, b * 0.6F + 0.1F);
         } else
         {
-            GL11.glColor3f(f1, f2, f3);
+            GL11.glColor3f(r, g, b);
         }
         GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
         GL11.glDepthMask(true);
     }
 
+    private float getCloudHeightModifier() {
+        return mc.gameSettings.cloudHeight.value * 128;
+    }
+
     public void renderClouds(float partialTick)
     {
         if(mc.theWorld.dimension == Dimension.nether)
@@ -973,7 +953,7 @@ public class RenderGlobal
         float cameraY = (float) mc.activeCamera.getY(partialTick);
         byte cloudRadius = 32;
         int i = 256 / cloudRadius;
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         GL11.glBindTexture(3553 /*GL_TEXTURE_2D*/, renderEngine.getTexture("/environment/clouds.png"));
         GL11.glEnable(3042 /*GL_BLEND*/);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -988,7 +968,7 @@ public class RenderGlobal
         int k = MathHelper.floor_double(posZ / 2048D);
         posX -= j * 2048;
         posZ -= k * 2048;
-        float cloudHeight = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F;
+        float cloudHeight = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
         float f10 = (float)(posX * (double)f6);
         float f11 = (float)(posZ * (double)f6);
         tessellator.startDrawingQuads();
@@ -1013,14 +993,30 @@ public class RenderGlobal
 
     public void renderCloudsFancy(float partialTick)
     {
+        glDisable(GL_FOG);
+        float celestialAngle = worldObj.getCelestialAngle(partialTick);
+        float[] sunriseColor = worldObj.worldType.getSunriseColor(celestialAngle, partialTick);
+        float rSun = 0.0f, gSun = 0.0f, bSun = 0.0f, aSun = 0.0f;
+        if (sunriseColor != null) {
+            rSun = sunriseColor[0];
+            gSun = sunriseColor[1];
+            bSun = sunriseColor[2];
+            aSun = sunriseColor[3] / 2;
+        }
+
+        Vec3d dimensionColor = worldObj.getDimensionColor(partialTick);
+        float rDim = (float)dimensionColor.xCoord;
+        float gDim = (float)dimensionColor.yCoord;
+        float bDim = (float)dimensionColor.zCoord;
+
         GL11.glDisable(GL11.GL_CULL_FACE);
         float cameraY = (float) mc.activeCamera.getY(partialTick);
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         float cloudWidth = 12F;
         float cloudThickness = 4F;
         double dx = (mc.activeCamera.getX(partialTick) + (double)((lastCloudOffsetX + (cloudOffsetX - lastCloudOffsetX) * partialTick) * 0.03F)) / (double)cloudWidth;
         double dz = (mc.activeCamera.getZ(partialTick) + (double)((lastCloudOffsetZ + (cloudOffsetZ - lastCloudOffsetZ) * partialTick) * 0.03F)) / (double)cloudWidth + 0.33D;
-        float dy = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F;
+        float dy = (worldObj.worldType.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
         int i = MathHelper.floor_double(dx / 2048D);
         int j = MathHelper.floor_double(dz / 2048D);
         dx -= i * 2048;
@@ -1028,24 +1024,21 @@ public class RenderGlobal
         GL11.glBindTexture(GL11.GL_TEXTURE_2D, renderEngine.getTexture("/environment/clouds.png"));
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        Vec3d color = worldObj.getDimensionColor(partialTick);
-        float red = (float)color.xCoord;
-        float green = (float)color.yCoord;
-        float blue = (float)color.zCoord;
         float f13 = 1F / 256F;
         float f9 = (float) MathHelper.floor_double(dx) * f13;
         float f11 = (float) MathHelper.floor_double(dz) * f13;
         float f14 = (float)(dx - (double) MathHelper.floor_double(dx));
         float f15 = (float)(dz - (double) MathHelper.floor_double(dz));
         int cloudWidthScale = 8;
-        byte radius = 3;
+        byte radius = 8;
         float f16 = 1F / 1024F;
         GL11.glScalef(cloudWidth, 1.0F, cloudWidth);
+        double maxDistance = Math.sqrt(Math.pow(6, 2) * 2);
         for(int l = 0; l < 2; l++)
         {
             if(l == 0)
             {
-                GL11.glColorMask(false, false, false, false);
+                GL11.glColorMask(false, false, false, true);
             } 
             else
             {
@@ -1056,13 +1049,22 @@ public class RenderGlobal
             {
                 for(int iz = -radius - 1; iz <= radius; iz++)
                 {
+                    double distance = Math.sqrt(Math.pow(ix, 2) + Math.pow(iz, 2));
+                    float distanceFactor = (1f - (float)(distance / maxDistance));
+                    if (distanceFactor > 0.75f) distanceFactor = 0.75f;
+                    distanceFactor *= 1.333333f;
+
+                    float red = rDim + (rSun - rDim) * aSun;
+                    float green = gDim + (gSun - gDim) * aSun;
+                    float blue = bDim + (bSun - bDim) * aSun;
+
                     float f17 = ix * cloudWidthScale;
                     float f18 = iz * cloudWidthScale;
                     float cloudX = f17 - f14;
                     float cloudZ = f18 - f15;
                     if(dy > -cloudThickness - 1.0F)
                     {
-                        tessellator.setColorRGBA_F(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F);
+                        tessellator.setColorRGBA_F(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F * distanceFactor);
                         tessellator.setNormal(0.0F, -1F, 0.0F);
                         tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + (float)cloudWidthScale, (f17 + 0.0F) * f13 + f9, (f18 + (float)cloudWidthScale) * f13 + f11);
                         tessellator.addVertexWithUV(cloudX + (float)cloudWidthScale, dy + 0.0F, cloudZ + (float)cloudWidthScale, (f17 + (float)cloudWidthScale) * f13 + f9, (f18 + (float)cloudWidthScale) * f13 + f11);
@@ -1071,14 +1073,14 @@ public class RenderGlobal
                     }
                     if(dy <= cloudThickness + 1.0F)
                     {
-                        tessellator.setColorRGBA_F(red, green, blue, 0.8F);
+                        tessellator.setColorRGBA_F(red, green, blue, 0.8F * distanceFactor);
                         tessellator.setNormal(0.0F, 1.0F, 0.0F);
                         tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + (float)cloudWidthScale, (f17 + 0.0F) * f13 + f9, (f18 + (float)cloudWidthScale) * f13 + f11);
                         tessellator.addVertexWithUV(cloudX + (float)cloudWidthScale, (dy + cloudThickness) - f16, cloudZ + (float)cloudWidthScale, (f17 + (float)cloudWidthScale) * f13 + f9, (f18 + (float)cloudWidthScale) * f13 + f11);
                         tessellator.addVertexWithUV(cloudX + (float)cloudWidthScale, (dy + cloudThickness) - f16, cloudZ + 0.0F, (f17 + (float)cloudWidthScale) * f13 + f9, (f18 + 0.0F) * f13 + f11);
                         tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
                     }
-                    tessellator.setColorRGBA_F(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F);
+                    tessellator.setColorRGBA_F(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F * distanceFactor);
                     if(ix > -1)
                     {
                         tessellator.setNormal(-1F, 0.0F, 0.0F);
@@ -1103,7 +1105,7 @@ public class RenderGlobal
                         }
 
                     }
-                    tessellator.setColorRGBA_F(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F);
+                    tessellator.setColorRGBA_F(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F * distanceFactor);
                     if(iz > -1)
                     {
                         tessellator.setNormal(0.0F, 0.0F, -1F);
@@ -1247,7 +1249,7 @@ public class RenderGlobal
 
     public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(3042 /*GL_BLEND*/);
         GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
         GL11.glBlendFunc(770, 1);
@@ -1384,7 +1386,7 @@ public class RenderGlobal
 		double offsetY = camera.getY(partialTicks);
 		double offsetZ = camera.getZ(partialTicks);
 		
-		TessellatorStandard tessellator = TessellatorStandard.instance;
+		Tessellator tessellator = Tessellator.instance;
 		tessellator.setTranslation(-offsetX, -offsetY, -offsetZ);
 		
 		int blockX = MathHelper.floor_double(mc.thePlayer.x);
@@ -1466,7 +1468,7 @@ public class RenderGlobal
 
     public void drawOutlinedBoundingBox(AABB axisalignedbb)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawing(GL11.GL_LINE_STRIP);
         tessellator.addVertex(axisalignedbb.minX, axisalignedbb.minY, axisalignedbb.minZ);
         tessellator.addVertex(axisalignedbb.maxX, axisalignedbb.minY, axisalignedbb.minZ);
@@ -1495,7 +1497,7 @@ public class RenderGlobal
 
     public void drawOutlinedVolume(BoundingVolume volume, double xOffset, double yOffset, double zOffset, float expand)
     {
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
         t.startDrawing(GL11.GL_LINES);
         Float[] points = volume.getBakedLineCoords();
         for (int i = 0; i < points.length; i += 3)
diff --git a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index fd8c3b159..1a53d964b 100644
--- a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -3,7 +3,7 @@ package net.minecraft.client.render;
 import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.tileentity.*;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.*;
